<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:java="http://xml.apache.org/xslt/java" xmlns:tmx="http://www.lisa.org/tmx14">
  <!-- For character entities: http://www.w3.org/MarkUp/html3/latin1.html -->
  <!-- The necessity for using xml namespaces all over and matching on namespaced element names http://www.stylusstudio.com/xsllist/200302/post70120.html -->

  <!-- HOW AND WHEN TO USE THIS FILE
       This file (obsolete) is used to produce the intermediate text file required from a translated TMX file sent in by the user. This intermediate text file, consisting of
       2 columns of data, is then fed into the existing pipeline of processing translated spreadsheets, so that translation updates can be committed back into the GS repository.
       
       This assumes that the file returned by the translator is a TMX file also. In practice, this is unlikely to be the case when using GTT, since it does not allow downloading
       of GTT files. That is why this XSLT file is obsolete.
       However, it's use on an input TMX file is explained below.


       1. Generate an xml file containing the chunks requiring work.
       GS2/bin/script> perl -S gti.pl get-first-n-chunks-requiring-work mi coredm 1000 > ../../macros/maori/mi-core.xml

       2. Generate a TMX file from that XML file as follows:
       GS2/bin/script> java -cp /research/ak19/gs2-svn/bin/java/ApplyXSLT.jar org.nzdl.gsdl.ApplyXSLT -x ../../macros/maori/mi-core.xml -t ../script/gti-generate-tmx-xml.xsl -l mi > ../../maori/core-mi.tmx

       3. Once the user has finished translating, and ONLY ASSUMING the file they return is a TMX file again, apply this XSLT to obtain the .txt required:
       GS2/bin/java>java -cp /research/ak19/gs2-svn/bin/java/ApplyXSLT.jar org.nzdl.gsdl.ApplyXSLT -x ../../maori/core-mi.tmx -t ../script/gti-tmx-to-txt.xsl > ../../maori/core-mi.txt
  
  
       4. Try processing this UTF-16 text file as before, as explained on the wiki: http://internal.greenstone.org/wiki/GTI

       > perl -S gti-process-spreadsheet.pl language.txt > language-submission.xml
       > cat language-submission.xml | perl -S gti.pl submit-translations language-code module-name username
       (There are extra steps when GLI help files are translated, see the internal.greenstone wiki page again).

    -->

  <xsl:output method="text" encoding="UTF-16"/> <!-- When we save as txt from Excel, we choose UTF-16 too -->

  <xsl:template match="tmx:tmx">
    <xsl:apply-templates select="tmx:body"/>
  </xsl:template>

  <xsl:template match="tmx:body">
    <xsl:text>Key&#09;Text</xsl:text>
    <xsl:text>&#10;&#10;</xsl:text> <!--2 newlines-->  
    <xsl:apply-templates select="tmx:tu"/>
  </xsl:template>

  <xsl:template match="tmx:tu">
    <xsl:for-each select="tmx:tuv">
      <xsl:if test="tmx:prop[@type='source']">
	<xsl:text>source::</xsl:text>
	<xsl:value-of select="tmx:prop"/>
	<xsl:text>&#09;</xsl:text><!-- tab -->
	<xsl:variable name="tempText1"><xsl:value-of select="tmx:seg"/></xsl:variable>
	<xsl:variable name="tempText2" select='java:org.nzdl.gsdl.ApplyXSLT.replaceAll($tempText1, "&amp;#10;&#10;", "\n")'/>
	<xsl:variable name="tempText3" select='java:org.nzdl.gsdl.ApplyXSLT.replaceAll($tempText2, "&amp;lt;", "&#60;")'/>
	<xsl:variable name="tempText4" select='java:org.nzdl.gsdl.ApplyXSLT.replaceAll($tempText3, "&amp;gt;", "&#62;")'/>
	<xsl:variable name="escapedText" select='java:org.nzdl.gsdl.ApplyXSLT.replaceAll($tempText4, "&amp;amp;", "&#38;")'/>
	<xsl:value-of select='$escapedText' disable-output-escaping="yes"/>
	<xsl:text>&#10;</xsl:text><!-- newline -->
	</xsl:if>
    </xsl:for-each>

    <xsl:for-each select="tmx:tuv">
      <xsl:if test="tmx:prop[@type='target']">
	<xsl:text>target::</xsl:text>
	<xsl:value-of select="tmx:prop"/>
	<xsl:text>&#09;</xsl:text><!-- tab -->
	<xsl:variable name="tempText1"><xsl:value-of select="tmx:seg"/></xsl:variable>
	<xsl:variable name="tempText2" select='java:org.nzdl.gsdl.ApplyXSLT.replaceAll($tempText1, "&amp;#10;&#10;", "\n")'/>
	<xsl:variable name="tempText3" select='java:org.nzdl.gsdl.ApplyXSLT.replaceAll($tempText2, "&amp;lt;", "&#60;")'/>
	<xsl:variable name="tempText4" select='java:org.nzdl.gsdl.ApplyXSLT.replaceAll($tempText3, "&amp;gt;", "&#62;")'/>
	<xsl:variable name="escapedText" select='java:org.nzdl.gsdl.ApplyXSLT.replaceAll($tempText4, "&amp;amp;", "&#38;")'/>
	<xsl:value-of select='$escapedText' disable-output-escaping="yes"/>
	<xsl:text>&#10;&#10;</xsl:text><!-- 2 newlines -->
      </xsl:if>
    </xsl:for-each>
  </xsl:template>

</xsl:stylesheet>
